const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DriversDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const drivers = await db.drivers.create(
      {
        id: data.id || undefined,

        full_name: data.full_name || null,
        license_number: data.license_number || null,
        license_issue_date: data.license_issue_date || null,
        id_copy_url: data.id_copy_url || null,
        license_copy_url: data.license_copy_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await drivers.setTenant(data.tenant || null, {
      transaction,
    });

    await drivers.setReservation(data.reservation || null, {
      transaction,
    });

    await drivers.setAgences(data.agences || null, {
      transaction,
    });

    return drivers;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const driversData = data.map((item, index) => ({
      id: item.id || undefined,

      full_name: item.full_name || null,
      license_number: item.license_number || null,
      license_issue_date: item.license_issue_date || null,
      id_copy_url: item.id_copy_url || null,
      license_copy_url: item.license_copy_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const drivers = await db.drivers.bulkCreate(driversData, { transaction });

    // For each item created, replace relation files

    return drivers;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const drivers = await db.drivers.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.full_name !== undefined) updatePayload.full_name = data.full_name;

    if (data.license_number !== undefined)
      updatePayload.license_number = data.license_number;

    if (data.license_issue_date !== undefined)
      updatePayload.license_issue_date = data.license_issue_date;

    if (data.id_copy_url !== undefined)
      updatePayload.id_copy_url = data.id_copy_url;

    if (data.license_copy_url !== undefined)
      updatePayload.license_copy_url = data.license_copy_url;

    updatePayload.updatedById = currentUser.id;

    await drivers.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await drivers.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.reservation !== undefined) {
      await drivers.setReservation(
        data.reservation,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await drivers.setAgences(
        data.agences,

        { transaction },
      );
    }

    return drivers;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const drivers = await db.drivers.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of drivers) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of drivers) {
        await record.destroy({ transaction });
      }
    });

    return drivers;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const drivers = await db.drivers.findByPk(id, options);

    await drivers.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await drivers.destroy({
      transaction,
    });

    return drivers;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const drivers = await db.drivers.findOne({ where }, { transaction });

    if (!drivers) {
      return drivers;
    }

    const output = drivers.get({ plain: true });

    output.tenant = await drivers.getTenant({
      transaction,
    });

    output.reservation = await drivers.getReservation({
      transaction,
    });

    output.agences = await drivers.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.reservations,
        as: 'reservation',

        where: filter.reservation
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reservation
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  ref: {
                    [Op.or]: filter.reservation
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.full_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('drivers', 'full_name', filter.full_name),
        };
      }

      if (filter.license_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'drivers',
            'license_number',
            filter.license_number,
          ),
        };
      }

      if (filter.id_copy_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('drivers', 'id_copy_url', filter.id_copy_url),
        };
      }

      if (filter.license_copy_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'drivers',
            'license_copy_url',
            filter.license_copy_url,
          ),
        };
      }

      if (filter.license_issue_dateRange) {
        const [start, end] = filter.license_issue_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            license_issue_date: {
              ...where.license_issue_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            license_issue_date: {
              ...where.license_issue_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.drivers.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('drivers', 'full_name', query),
        ],
      };
    }

    const records = await db.drivers.findAll({
      attributes: ['id', 'full_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['full_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.full_name,
    }));
  }
};
